
#include "config.h"
#include "EEPROM.h"

#define EE_ADDRESS1	0x0000

extern int   edata g_x,g_y,g_z;		//ǽ
extern float edata a_x,a_y;			//ǶȽ
extern float edata AngleX,AngleY;

u8	edata	tmp[20];

//========================================================================
// : void	ISP_Disable(void)
// : ֹISP/IAP.
// : non.
// : non.
// 汾: V1.0, 2021-10-22
//========================================================================
void	DisableEEPROM(void)
{
	ISP_CONTR = 0;			//ֹISP/IAP
	IAP_TPS   = 0;
	ISP_CMD   = 0;			//ȥISP/IAP
	ISP_TRIG  = 0;			//ֹISP/IAP󴥷
	IAP_ADDRE = 0xff;
	ISP_ADDRH = 0xff;		//0ַֽ
	ISP_ADDRL = 0xff;		//0ַֽڣָEEPROMֹ
}

//========================================================================
// : void EEPROM_read_n(u16 EE_address,u8 *DataAddress,u16 number)
// : ָEEPROM׵ַnֽڷָĻ.
// : EE_address:  EEPROM׵ַ.
//       DataAddress: ݷŻ׵ַ.
//       number:      ֽڳ.
// : non.
// 汾: V1.0, 2021-10-22
//========================================================================
void EEPROM_read_n(u16 EE_address,u8 *DataAddress,u16 number)
{
	EA = 0;		//ֹж
	IAP_ADDRE = 0x00;
	ISP_CONTR = ISP_EN;						//ISP/IAP
	IAP_TPS = (u8)(MAIN_Fosc / 1000000L);	//Ƶ
	ISP_READ();								//ֽڶıʱ
	do
	{
		ISP_ADDRH = EE_address / 256;		//͵ַֽڣַҪıʱ͵ַ
		ISP_ADDRL = EE_address % 256;		//͵ַֽ
		ISP_TRIG();							//5AHA5HISP/IAPĴÿζҪ
											//A5HISP/IAP
											//CPUȴIAPɺ󣬲Żִг
		_nop_();
		_nop_();
		_nop_();
		*DataAddress = ISP_DATA;			//
		EE_address++;
		DataAddress++;
	}while(--number);

	DisableEEPROM();
	EA = 1;		//ж
}


/********************  *****************/
//========================================================================
// : void EEPROM_SectorErase(u16 EE_address)
// : ַָEEPROM.
// : EE_address:  ҪEEPROMĵַ.
// : non.
// 汾: V1.0, 2021-10-22
//========================================================================
void EEPROM_SectorErase(u16 EE_address)
{
	EA = 0;		//ֹж
											//ֻûֽڲ512ֽ/
											//һֽڵַַ
	IAP_ADDRE = 0x00;
	ISP_ADDRH = EE_address / 256;			//ַֽڣַҪıʱ͵ַ
	ISP_ADDRL = EE_address % 256;			//ַֽ
	ISP_CONTR = ISP_EN;						//ISP/IAP
	IAP_TPS = (u8)(MAIN_Fosc / 1000000L);	//Ƶ
	ISP_ERASE();							//ıʱ
	ISP_TRIG();
	_nop_();
	_nop_();
	_nop_();
	DisableEEPROM();
	EA = 1;		//ж
}

//========================================================================
// : void EEPROM_write_n(u16 EE_address,u8 *DataAddress,u16 number)
// : ѻnֽдָ׵ַEEPROM.
// : EE_address:  дEEPROM׵ַ.
//       DataAddress: дԴݵĻ׵ַ.
//       number:      дֽڳ.
// : non.
// 汾: V1.0, 2021-10-22
//========================================================================
void EEPROM_write_n(u16 EE_address,u8 *DataAddress,u16 number)
{
	EA = 0;		//ֹж

	IAP_ADDRE = 0x00;
	ISP_CONTR = ISP_EN;						//ISP/IAP
	IAP_TPS = (u8)(MAIN_Fosc / 1000000L);	//Ƶ
	ISP_WRITE();							//ֽдıʱ
	do
	{
		ISP_ADDRH = EE_address / 256;		//͵ַֽڣַҪıʱ͵ַ
		ISP_ADDRL = EE_address % 256;		//͵ַֽ
		ISP_DATA  = *DataAddress;			//ݵISP_DATAֻݸıʱ
		ISP_TRIG();
		_nop_();
		_nop_();
		_nop_();
		EE_address++;
		DataAddress++;
	}while(--number);

	DisableEEPROM();
	EA = 1;		//ж
}



void IAP_Gyro(void)   //У׼
{
	u8	i,j;
	((int *)&tmp)[0] = g_x;	//ȡ
	((int *)&tmp)[1] = g_y; 
	((int *)&tmp)[2] = g_z;
	((int *)&tmp)[3] = 0x55aa;

	((float *)&tmp)[2] = a_x;
	((float *)&tmp)[3] = a_y;

	for(i=0,j=0; i<16; i++)	j += tmp[i];
	j = ~j + 1;
	tmp[i] = j;

	EEPROM_SectorErase(EE_ADDRESS1); //
	EEPROM_write_n(EE_ADDRESS1, tmp, 17);
}

void IAPRead(void)		//ȡǾ
{
	u8	i,j;

	EEPROM_read_n(EE_ADDRESS1, tmp, 17);
	for(i=0,j=0; i<17; i++)	j += tmp[i];

	if((j == 0) && (((int *)&tmp)[3] == 0x55aa))		//жǷѾ¹¹Ŷȡ
	{
		g_x = ((int *)&tmp)[0];
		g_y = ((int *)&tmp)[1];
		g_z = ((int *)&tmp)[2];
		a_x = ((float *)&tmp)[2];
		a_y = ((float *)&tmp)[3];
	}
	else
	{
		g_x = 0;
		g_y = 0;
		g_z = 0;
		a_x = 0;
		a_y = 0;
	}

}

