
#include "config.h"
#include "NRF24L01.H"
#include "MPU6050.H"
#include "EEPROM.H"
#include <math.H>


sbit	P_Light  = P1^7;	//
sbit	P_BUZZER = P4^0;	//
#define	LightBuzzerSet()	P1n_push_pull(Pin7); P4n_push_pull(Pin0)

u8 edata TxBuf[20]={0};		//RF
u8 edata RxBuf[20]={0};		//RF 

int		edata g_x=0,g_y=0,g_z=0;					//ǽ
float	edata a_x=0,a_y=0;							//ǶȽ
float	edata AngleX=0,AngleY=0;					//Ԫŷ
float	edata Angle_gx=0,Angle_gy=0,Angle_gz=0;		//ɽٶȼĽ(Ƕ)
float	edata Angle_ax=0,Angle_ay=0,Angle_az=0;		//ɼٶȼļٶ()
float	edata Ax=0,Ay=0,Az=0;						//ңĽǶ    
float	edata PID_x=0,PID_y=0,PID_z=0;				//PID
int		edata speed0=0,speed1=0,speed2=0,speed3=0;	//ٶȲ
int		edata PWM0=1000,PWM1=1000,PWM2=1000,PWM3=1000;		//PWMģĲ

int		int_tmp;
u8		YM=0,FRX=128,FRY=128,FRZ=128;				//4ͨңź.
u8		edata	tp[16];		//MP6050


//****************̬PID*********************************************

float edata Out_PID_X=0,Last_Angle_gx=0;					//⻷PI  һ
float edata ERRORX_Out=0,ERRORX_In=0;			//⻷P  ⻷I  ⻷
float edata Out_PID_Y=0,Last_Angle_gy=0;
float edata ERRORY_Out=0,ERRORY_In=0;            //1:⻷P˻10.5

float edata Last_Ax=0,Last_Ay=0,Last_Az=0;


/******************************************************************************/
//	#define	PID_MODE	0	// PIDģʽ
	#define	PID_MODE	5	// DIY F380  2212 9450ҽ

#if (PID_MODE == 0)	/* PIDģʽ */
	float edata	Out_XP = 6.65f;		//ADC0	⻷P	V1 / 10
	float edata	Out_XI = 0.0074f;	//ADC4	⻷I	V2 / 10000
	float edata	Out_XD = 6.0;		//ADC5	⻷D	V3 / 10

	float edata	In_XP =	0.8275f;	//ADC6	ڻP	V4 / 100
	float edata	In_XI =	0.0074f;	//ADC4	ڻI	V2 / 10000
	float edata	In_XD =	6.0f;		//ADC5	ڻD	V3 / 10
#endif

#if (PID_MODE == 5)		//DIY F380  2212 9450ҽ		, ½ʱС(ƽ, Ƕ/4.0)
	#define	Out_XP	6.65f	//ADC0	⻷P	V1 / 10
	#define	Out_XI	0.0074f	//ADC4	⻷I	V2 / 10000
	#define	Out_XD	6.0f	//ADC5	⻷D	V3 / 10

	#define	In_XP	0.8275f	//ADC6	ڻP	V4 / 100
	#define	In_XI	0.0074f	//ADC4	ڻI	V2 / 10000
	#define	In_XD	6.0f	//ADC5	ڻD	V3 / 10
#endif


#define	Out_YP	Out_XP
#define	Out_YI	Out_XI
#define	Out_YD	Out_XD

#define	In_YP	In_XP
#define	In_YI	In_XI
#define	In_YD	In_XD


//=================== ƵP I D ==================================

//float ZP=5.0,ZI=0.1;	//ƵP D

#define	ZP	5.0f
#define	ZI	0.1f
#define	ZD	4.0f	//ƵP D

float Z_integral=0;//Z

#define	ERR_MAX	500
//======================================================================


u8	edata lastR0=0, RF_LostCnt=0; //һRxBuf[0](RxBuf[0]ڲϱ䶯)   ״̬ʶ


//======================================================================
bit	B_8ms;	//8ms־

bit	B_rtn_msg;	//󷵻Ϣ
bit	B_BAT_LOW;	//͵ѹ־
u8	cnt_ms;		//ʱ

u16	edata Battery = 1200;		//صѹ
u16	edata ADC6_Last = 2495*4;	//ADC˲ֵ



#define		Baudrate1			115200UL
#define		TX1_LENGTH	128

u8		edata UART1_cmd=0;	//
u8		edata TX1_Read=0;	//Ͷָ
u8		edata TX1_Write=0;	//дָ
u8 		edata TX1_Buffer[TX1_LENGTH];	//ͻ
bit		B_TX1_Busy;			//æ־

u8		edata Cal_Setp=0;			//У׼
u8		edata Cal_cnt=0;			//У׼ƽֵ
int		edata x_sum,y_sum,z_sum;	//У׼ۼӺ
float	edata float_x_sum,float_y_sum;	//У׼ۼӺ

u8	edata BuzzerOnTime,BuzzerOffTime,BuzzerRepeat,BuzzerOnCnt,BuzzerOffCnt;	//ر
u8	edata cnt_100ms;

//================================================


void	UART1_config(void);
void 	PrintString1(u8 *puts);	//һַ
void	TX1_write2buff(u8 dat);	//д뷢ͻ壬ָ+1
void	TX1_int_value(int i);
void	delay_ms(u16 ms);
void	Return_Message(void);
u16 	MODBUS_CRC16(u8 *p,u8 n);	//input:	*p--->First Data Address,n----->Data Number,	return:	CRC16
void 	ADC_Config(void);
void 	AD_Battery(void);

extern	u8	PWMA_ISR_En;	//ÿͨԵжϴ, bit4:ͨ4, bit3:ͨ3, bit2:ͨ2, bit1:ͨ1.

void	PWMA_config(void);



//*********************************************************************
//****************Ƕȼ*********************************************
//*********************************************************************
#define	pi		3.14159265f                           
#define	Kp		0.8f                        
#define	Ki		0.001f                         
#define	halfT	0.004f           

float edata q0=1,q1=0,q2=0,q3=0;   
float edata exInt=0,eyInt=0,ezInt=0;  


void IMUupdate(float gx, float gy, float gz, float ax, float ay, float az)
{
	float edata norm;
	float edata vx, vy, vz;
	float edata ex, ey, ez;

	norm = sqrt(ax*ax + ay*ay + az*az);	//ѼٶȼƵάתɵά   
	ax = ax / norm;
	ay = ay / norm;
	az = az / norm;

		//	ǰԪɡҾеĵеԪء 
		//	ҾŷǵĶ壬ϵתϵԪ
		//	vx vy vzʵǵǰŷǣԪĻϵϣ
		//	λ
	vx = 2*(q1*q3 - q0*q2);
	vy = 2*(q0*q1 + q2*q3);
	vz = q0*q0 - q1*q1 - q2*q2 + q3*q3 ;

	ex = (ay*vz - az*vy) ;
	ey = (az*vx - ax*vz) ;
	ez = (ax*vy - ay*vx) ;

	exInt = exInt + ex * Ki;
	eyInt = eyInt + ey * Ki;
	ezInt = ezInt + ez * Ki;

	gx = gx + Kp*ex + exInt;
	gy = gy + Kp*ey + eyInt;
	gz = gz + Kp*ez + ezInt;

	q0 = q0 + (-q1*gx - q2*gy - q3*gz) * halfT;
	q1 = q1 + ( q0*gx + q2*gz - q3*gy) * halfT;
	q2 = q2 + ( q0*gy - q1*gz + q3*gx) * halfT;
	q3 = q3 + ( q0*gz + q1*gy - q2*gx) * halfT;

	norm = sqrt(q0*q0 + q1*q1 + q2*q2 + q3*q3);
	q0 = q0 / norm;
	q1 = q1 / norm;
	q2 = q2 / norm;
	q3 = q3 / norm;

	AngleX = asin(2*(q0*q2 - q1*q3 )) * 57.2957795f; //    ɶ
	AngleY = asin(2*(q0*q1 + q2*q3 )) * 57.2957795f; // 
}


//****************̬*********************************************
//void Angle_Calculate(void) interrupt 1	//Timer0 ж
void PWMA_ISR(void) interrupt PWMA_VECTOR	//PWMжϺ, @24MHz2ms, жMPU-6050Ҫ720us, Ԫ0.8~1.0ms.
{
//	u8	sr1, sr2;
//	sr1 = PWMA_SR1;	//Ϊ˿, жϱ־һֲ
	PWMA_SR1 = 0;	//жϱ־
//	sr2 = PWMA_SR2;	//Ϊ˿, жϱ־һֲ
	PWMA_SR2 = 0;	//жϱ־
//	sr1 &= PWMA_ISR_En;	//ÿͨԵжϴ

//	if(sr1 & 0x01)	//ж

	B_8ms = 1;		//8ms־

	if(RxBuf[0] == lastR0)	//RxBuf[0]ûյ ʧ
	{
		if(++RF_LostCnt >= 250)	//ʧ2
		{
			RF_LostCnt = 200;	//ظ0.4룬ʧر
			if(RxBuf[4] != 0)	RxBuf[4]--;
		}
		if(RF_LostCnt >= 25)	//ʧ200ms
		{
			RxBuf[1] = 128;
			RxBuf[2] = 128; //  0
			RxBuf[3] = 128;
		}
	}
	else	RF_LostCnt = 0;
	lastR0 = RxBuf[0];

	FRX = RxBuf[1];	//
	FRY = RxBuf[2];	//
	FRZ = RxBuf[3];	//
	YM  = RxBuf[4];	//
	if(YM >= 190)	YM = 190;	//һռ䣬ʱƫ


//********************************************************************************************
	Read_MPU6050(tp);	// 720us @24MHz

	Angle_ax = ((float)(((int *)&tp)[0])) / 8192.0;	//ٶȴ	λ +- g
	Angle_ay = ((float)(((int *)&tp)[1])) / 8192.0;	//תϵ	8192 LSB/g, 1gӦ8192
	Angle_az = ((float)(((int *)&tp)[2])) / 8192.0;	//ٶ +-4g/S
	Last_Angle_gx = Angle_gx;		//һνٶ
	Last_Angle_gy = Angle_gy;
	Angle_gx = ((float)(((int *)&tp)[4] - g_x)) / 65.5;	//Ǵ	λ +-
	Angle_gy = ((float)(((int *)&tp)[5] - g_y)) / 65.5;	// +-500/S, 1/ Ӧ 65.536
	Angle_gz = ((float)(((int *)&tp)[6] - g_z)) / 65.5;	//תϵ65.5 LSB/

	IMUupdate(Angle_gx*0.0174533f, Angle_gy*0.0174533f, Angle_gz*0.0174533f, Angle_ax,Angle_ay,Angle_az);	// 0.8~1.0ms @24MHz

//**********************************Xָ************************************************
	Ax  = AngleX - a_x - ((float)FRX - 128) / 4.0;		//ǶȿǶ

	if(YM > 20)	ERRORX_Out += Ax,	ERRORX_Out += Ax,	ERRORX_Out += Ax;	//⻷(Сĳֵʱ)
	else		ERRORX_Out = 0; //Сڶֵʱֵ
		 if(ERRORX_Out >  1500)	ERRORX_Out =  1500;
	else if(ERRORX_Out < -1500)	ERRORX_Out = -1500;	//޷

	Out_PID_X = Ax*Out_XP + ERRORX_Out*Out_XI + (Ax-Last_Ax)*Out_XD;	//⻷PID
	Last_Ax = Ax;
	
	if(YM > 20)	ERRORX_In += (Angle_gy - Out_PID_X);	//ڻ(Сĳֵʱ)
	else		ERRORX_In = 0;	//Сڶֵʱֵ
		 if(ERRORX_In >  500)	ERRORX_In =  500;
	else if(ERRORX_In < -500)	ERRORX_In = -500;	//޷

	PID_x = (Angle_gy + Out_PID_X) * In_XP + ERRORX_In * In_XI + (Angle_gy - Last_Angle_gy) * In_XD;	//ڻPID
	if(PID_x >  500)	PID_x =  500;	//޷
	if(PID_x < -500)	PID_x = -500;

//**************Yָ**************************************************
	Ay  = AngleY - a_y + ((float)FRY - 128) / 4.0;		//ǶȿǶ
	
	if(YM > 20)	ERRORY_Out += Ay,	ERRORY_Out += Ay,	ERRORY_Out += Ay;	//⻷(Сĳֵʱ)
	else		ERRORY_Out = 0; //Сڶֵʱֵ
		 if(ERRORY_Out >  1500)	ERRORY_Out =  1500;
	else if(ERRORY_Out < -1500)	ERRORY_Out = -1500;	//޷
	
	Out_PID_Y = Ay * Out_YP + ERRORY_Out * Out_YI + (Ay-Last_Ay)*Out_YD;	//⻷PID
	Last_Ay = Ay;

	if(YM > 20)	ERRORY_In += (Angle_gx - Out_PID_Y);  //ڻ(Сĳֵʱ)
	else		ERRORY_In = 0; //Сڶֵʱֵ
		 if(ERRORY_In >  500)	ERRORY_In =  500;
	else if(ERRORY_In < -500)	ERRORY_In = -500;	//޷
	
	PID_y = (Angle_gx + Out_PID_Y) * In_YP + ERRORY_In * In_YI + (Angle_gx - Last_Angle_gx) * In_YD;	//ڻPID
	
	if(PID_y > 500)	PID_y =  500;	//޷
	if(PID_y <-500)	PID_y = -500;
	
//**************Zָ*****************************	
	Az = Angle_gz - ((float)FRZ - 128);
	
	if(YM > 20)	Z_integral += Az;	//Z
	else		Z_integral = 0;		//С40
		 if(Z_integral >  1000.0f)	Z_integral =  1000.0f;	//޷
	else if(Z_integral < -1000.0f)	Z_integral = -1000.0f;	//޷

	PID_z = Az * ZP + Z_integral * ZI + (Az - Last_Az) * ZD;
	Last_Az = Az;
	if(PID_z >  200)	PID_z =  200;	//޷
	if(PID_z < -200)	PID_z = -200;

	speed0 = (int)(  PID_x + PID_y - PID_z);	//ٶֵ
	speed1 = (int)(  PID_x - PID_y + PID_z);
	speed2 = (int)(0-PID_x - PID_y - PID_z);
	speed3 = (int)(  PID_y - PID_x + PID_z);

//**************ٶȲPWMģ*************************************************	
	if(YM < 10)	PWM0 = 1000, PWM1 = 1000, PWM2 = 1000, PWM3 = 1000;
	else
	{
		int_tmp = 1000 + (int)YM * 4;	//1000 + ,  1000ٶΪ0ʱӦ1ms

		PWM0 = int_tmp + speed0;	// +ٶֵ
			 if(PWM0 > 2000)	PWM0 = 2000;    //ٶȲƣֹPWMΧ0-1000
		else if(PWM0 < 1000)	PWM0 = 1000;

		PWM1 = int_tmp + speed1;	// +ٶֵ
			 if(PWM1 > 2000)	PWM1 = 2000;
		else if(PWM1 < 1000)	PWM1 = 1000;

		PWM2 = int_tmp + speed2;	// +ٶֵ
			 if(PWM2 > 2000)	PWM2 = 2000;
		else if(PWM2 < 1000)	PWM2 = 1000;

		PWM3 = int_tmp + speed3;	// +ٶֵ
			 if(PWM3 > 2000)	PWM3 = 2000;
		else if(PWM3 < 1000)	PWM3 = 1000;
	}

	PWMA_CCR1H  = PWM0/256;	// Ƚֵ, ռձ(ߵƽʱ)
	PWMA_CCR1L  = PWM0%256;
	PWMA_CCR2H  = PWM1/256;	// Ƚֵ, ռձ(ߵƽʱ)
	PWMA_CCR2L  = PWM1%256;
	PWMA_CCR3H  = PWM2/256;	// Ƚֵ, ռձ(ߵƽʱ)
	PWMA_CCR3L  = PWM2%256;
	PWMA_CCR4H  = PWM3/256;	// Ƚֵ, ռձ(ߵƽʱ)
	PWMA_CCR4L  = PWM3%256;
}

/**********************  ************************/
void	beep(void)	//100ms
{
	if(BuzzerRepeat > 0)	//, ظΪ0Ҫ
	{
		if((BuzzerOnCnt == 0) && (BuzzerOffCnt == 0))	//OnOFFΪ0ʼװOnOffʱ
		{
			P_BUZZER = 1;			//
			BuzzerOnCnt  = BuzzerOnTime;	//װon
			BuzzerOffCnt = BuzzerOffTime;	//װoff
		}
		else if(BuzzerOnCnt  > 0)	{if(--BuzzerOnCnt == 0)	P_BUZZER = 0;}	//Onʱ
		else if(BuzzerOffCnt > 0)	//Offʱ
		{
			if(--BuzzerOffCnt == 0)	BuzzerRepeat--;
		}
	}
	else	P_BUZZER = 0;
}

void	SetBuzzer(u8 on,u8 off,u8 rep)	// rep: ظ, on: onʱ, off: offʱ
{
	BuzzerRepeat = rep;
	BuzzerOnTime  = on;
	BuzzerOffTime = off;
	if(BuzzerOnTime  == 0)	BuzzerOnTime  = 1;
	if(BuzzerOffTime == 0)	BuzzerOffTime = 1;
	if(BuzzerRepeat == 1)	BuzzerOffTime = 1;
	BuzzerOnCnt = 0,	BuzzerOffCnt = 0;
}

// ===================== ԶУ׼ =====================
void	AutoCal(void)
{
	if(RxBuf[4] < 10)	//ֹͣʱУ׼
	{
		if(Cal_Setp == 1)	//У׼
		{
			x_sum = 0;	y_sum = 0;	z_sum = 0;
			Cal_cnt  = 0;
			Cal_Setp = 2;
		}
		else if(Cal_Setp == 2)	//ۼ
		{
			x_sum += ((int *)&tp)[4];  //ȡ
			y_sum += ((int *)&tp)[5];
			z_sum += ((int *)&tp)[6];
			if(++Cal_cnt >= 64)
			{
				g_x = x_sum / 64;
				g_y = y_sum / 64;
				g_z = z_sum / 64;
				float_x_sum = 0;	float_y_sum = 0;
				Cal_cnt  = 0;
				Cal_Setp = 3;
			}
		}
		else if(Cal_Setp == 3)	//X YǶۼ
		{
			float_x_sum += AngleX;
			float_y_sum += AngleY;
			if(++Cal_cnt >= 64)
			{
				Cal_cnt  = 0;
				Cal_Setp = 0;
				a_x = float_x_sum / 64.0;
				a_y = float_y_sum / 64.0;
				IAP_Gyro();
				SetBuzzer(5,1,1);
			}
		}
	}
	else
	{
		Cal_Setp = 0;
		Cal_cnt  = 0;
	}
}

// =====================  =====================
void main(void)
{
	u8 i=0x55;
	WTST = 0;

	//I/OȫΪ׼˫ģʽ
	P0M0=0x00;	P0M1=0x00;
	P1M0=0x00;	P1M1=0x00;
	P2M0=0x00;	P2M1=0x00;
	P3M0=0x00;	P3M1=0x00;
	P4M0=0x00;	P4M1=0x00;
	P5M0=0x00;	P5M1=0x00;
	P6M0=0x00;	P6M1=0x00;
	P7M0=0x00;	P7M1=0x00;

	P_Light  = 0;
	P_BUZZER = 0;
	LightBuzzerSet();	//úƿIOIOΪ

	PWMA_config(); 

	init_NRF24L01();//ʼģ
 	ADC_Config();
	SetRX_Mode();

	while(i)
	{ 
		delay_ms(1);
		if(P_24L01_IRQ == 0)
		{
			nRF24L01_RxPacket(RxBuf);
			if((RxBuf[0]>0) && (MODBUS_CRC16(RxBuf,20)==0))	i = 0;	//CRCУ
		}
	}

	IAPRead();		//ȡǾ
	InitMPU6050();	//ʼMPU-6050
	delay_ms(100);

	RxBuf[1] = 128;
	RxBuf[2] = 128;
	RxBuf[3] = 128;
	RxBuf[4] = 0;
	
	PWMA_SR1 = 0;	//жϱ־
	PWMA_SR2 = 0;	//жϱ־
	PWMA_ISR_En|= 0x01;		// ʹܸж
	PWMA_IER    = PWMA_ISR_En;	//ͨ1~4жϴ
	EA = 1;	//ж
	
	SetBuzzer(5,1,1);

//==============================================
	UART1_config();	// ѡ, 2: ʹTimer2, ֵ: ʹTimer1.
	PrintString1("STC32Gϵɿس!\r\n");	//SUART1һַ
//==============================================


	while(1)
	{
		if(P_24L01_IRQ == 0)	//RFյ
		{
			nRF24L01_RxPacket(RxBuf);	//RF

			if(MODBUS_CRC16(RxBuf,20) == 0)	//CRCУ
			{

			#if (PID_MODE == 0)	// PIDģʽ
				if(RxBuf[4] < 15)
				{
					Out_XP = (float)RxBuf[7]  / 10;		//V1 ADC0	17.5f	//⻷P
					Out_XI = (float)RxBuf[8]  / 10000;	//V2 ADC4	0.01f	//0.1f	//⻷I
					Out_XD = (float)RxBuf[9]  / 10;		//V3 ADC5	5.0;	//⻷D

					In_XP  = (float)RxBuf[10] / 100;	//V4 ADC6	0.375f	//ڻP
					In_XI  = (float)RxBuf[8]  / 10000;	//V2		0.01f	//ڻI
					In_XD  = (float)RxBuf[9]  / 10;		//V3		7.0f	//ڻD
				}
			#endif

				if(RxBuf[5] == 1)	//У׼
				{
					RxBuf[5] = 0;
					if(RxBuf[4] < 10)		//ֹͣʱУ׼
					{
						SetBuzzer(2,1,1);
						Cal_Setp = 1;
					}
				}
			}	//CRCУ
		}

		if(B_8ms)		//8ms
		{
			B_8ms = 0;

			if(Cal_Setp != 0)	AutoCal();	//ǷִԶУ׼
			AD_Battery();	// ADCѹ

			if(++cnt_100ms >= 12)	cnt_100ms = 0,	beep();	//100msһη

			B = cnt_ms;		// ʱ϶
			++cnt_ms;
			B = (B ^ cnt_ms) & cnt_ms;

		//	if(B0)	{}		//16ms
		//	else if(B1)		//32ms
		//	else if(B2)		//64ms
			if(B2)		//64ms
			{
				if(!B_BAT_LOW && (RF_LostCnt < 120))	P_Light = 1;	//ѹ, ź,  ʱ, һ(ÿ2048ms64ms)
			}
		//	else if(B3)		//128ms
			else if(B4)		//256ms
			{
				if(B_BAT_LOW || (RF_LostCnt >= 120))	P_Light = ~P_Light;		//ѹ  RFź, ˸ 2HZ
			
			}
		//	else if(B5)		//512ms
			else if(B6)		//1024ms
			{
					 if(Battery < 1090)		B_BAT_LOW = 1;	//ѹ
				else if(Battery > 1110)		B_BAT_LOW = 0;	//ѹ
				
				if(B_BAT_LOW)	SetBuzzer(1,1,2);	//ѹ, 2
				if(B_rtn_msg)	Return_Message();	//󷵻صϢ
				if(!B_BAT_LOW && (RF_LostCnt < 120))	P_Light = 1;	//ѹ RFź, Ƴ
			}
			else if(B7)		//2048ms
			{
				if((RF_LostCnt >= 120) && !B_BAT_LOW)	SetBuzzer(1,1,3);	//ңźŶʧ
			}
		}


		if(UART1_cmd != 0)
		{
			if(UART1_cmd == 'a')
			{
				B_rtn_msg = ~B_rtn_msg;
			}
			UART1_cmd = 0;
		}
		
		
		if((TX1_Read != TX1_Write) && (!B_TX1_Busy))	//Ҫ, ҷͿ
		{
			SBUF = TX1_Buffer[TX1_Read];
			B_TX1_Busy = 1;
			if(++TX1_Read >= TX1_LENGTH)	TX1_Read = 0;
		}

	}
}

//=========================================================

void	Return_Message(void)
{
/*	PrintString1("ADC6=");
	TX1_write2buff((u8)(adc6/1000 + '0'));
	TX1_write2buff((u8)((adc6%1000)/100 + '0'));
	TX1_write2buff((u8)((adc6%100)/10 + '0'));
	TX1_write2buff((u8)(adc6%10 + '0'));
	TX1_write2buff(' ');
*/
	TX1_write2buff('V');
	TX1_write2buff('=');
	TX1_write2buff((u8)(Battery/1000 + '0'));
	TX1_write2buff((u8)((Battery%1000)/100 + '0'));
	TX1_write2buff('.');
	TX1_write2buff((u8)((Battery%100)/10 + '0'));
	TX1_write2buff((u8)(Battery%10 + '0'));
	TX1_write2buff(' ');
	TX1_write2buff(' ');

	PrintString1("AngleX=");
	TX1_int_value((int)(AngleX * 10));

	PrintString1("AngleY=");
	TX1_int_value((int)(AngleY * 10));

	PrintString1("AngleZ=");
	TX1_int_value((int)(Angle_gz * 10));

	PrintString1("a_x=");
	TX1_int_value(a_x * 10);
	PrintString1("a_y=");
	TX1_int_value(a_y * 10);
	PrintString1("g_z=");
	TX1_int_value(g_z * 10);

	TX1_write2buff(0x0d);
	TX1_write2buff(0x0a);
}


//******* ʱڳʼ 1~65535ms******************
void  delay_ms(u16 ms)
{
     u16 i;
	 do
	 {
	 	i = MAIN_Fosc / 6000;
		while(--i)	;
     }while(--ms);
}


void	TX1_int_value(int i)
{
	if(i < 0)	TX1_write2buff('-'),	i = 0 - i;
	else		TX1_write2buff(' ');
	TX1_write2buff((u8)(i / 1000 + '0'));
	TX1_write2buff((u8)((i % 1000) / 100 + '0'));
	TX1_write2buff((u8)((i % 100) / 10 + '0'));
	TX1_write2buff('.');
	TX1_write2buff((u8)(i % 10 + '0'));
	TX1_write2buff(' ');
	TX1_write2buff(' ');
}

/*************** װش1ͻ *******************************/
void TX1_write2buff(u8 dat)	//д뷢ͻ壬ָ+1
{
	TX1_Buffer[TX1_Write] = dat;
	if(++TX1_Write >= TX1_LENGTH)	TX1_Write = 0;
}


//========================================================================
// : void PrintString1(u8 *puts)
// : 1ַ
// : puts:  ַָ.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void PrintString1(u8 *puts)	//һַ
{
	for (; *puts != 0;	puts++)   TX1_write2buff(*puts);	//ֹͣ0
}


//========================================================================
// : void	UART1_config(u8 brt)
// : UART1ʼ
// : brt: ѡ, 2: ʹTimer2, ֵ: ʹTimer1.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void	UART1_config(void)
{
	/*********** ʹöʱ1 *****************/
	TR1 = 0;
	AUXR &= ~0x01;		//S1 BRT Use Timer1;
	AUXR |=  (1<<6);	//Timer1 set as 1T mode
	TMOD &= ~(1<<6);	//Timer1 set As Timer
	TMOD &= ~0x30;		//Timer1_16bitAutoReload;
	TH1 = (u8)((65536UL - (MAIN_Fosc / 4) / Baudrate1) / 256);
	TL1 = (u8)((65536UL - (MAIN_Fosc / 4) / Baudrate1) % 256);
	ET1 = 0;	//ֹж
	INTCLKO &= ~0x02;	//ʱ
	TR1  = 1;

	SCON = (SCON & 0x3f) | 0x40;	//UART1ģʽ, 0x00: ͬλ, 0x40: 8λ,ɱ䲨, 0x80: 9λ,̶, 0xc0: 9λ,ɱ䲨
	PS  = 1;	//ȼж
	ES  = 1;	//ж
	REN = 1;	//
	P_SW1 &= 0x3f;
	P_SW1 |= 0x00;		//UART1 switch to, 0x00: P3.0 P3.1, 0x40: P3.6 P3.7, 0x80: P1.6 P1.7 (ʹڲʱ)
//	PCON2 |=  (1<<4);	//ڲ·RXDTXD, м, ENABLE,DISABLE

	B_TX1_Busy = 0;
	TX1_Read   = 0;
	TX1_Write  = 0;
	UART1_cmd  = 0;
}


//========================================================================
// : void UART1_int (void) interrupt UART1_VECTOR
// : UART1жϺ
// : nine.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void UART1_int (void) interrupt 4
{
	if(RI)
	{
		RI = 0;
		UART1_cmd = SBUF;
	}

	if(TI)
	{
		TI = 0;
		B_TX1_Busy = 0;
	}
}

/****************************** CRC16 (shift) *************** past test 2006-11-27 *********
	CRC÷ʽ	MODBUS_CRC16(&CRC,8);	&CRCΪ׵ַ8Ϊֽ
	CRC-16 for MODBUS
	CRC16=X16+X15+X2+1
	TEST: ---> ABCDEFGHIJ	CRC16=0x0BEE
*/
//========================================================================
// : u16	MODBUS_CRC16(u8 *p, u8 n)
// : CRC16.
// : *p: Ҫָ.
//        n: Ҫֽ.
// : CRC16ֵ.
// 汾: V1.0, 2022-3-18 
//========================================================================
u16	MODBUS_CRC16(u8 *p, u8 n)
{
	u8	i;
	u16	crc16;
	
	crc16 = 0xffff;	//Ԥ16λCRCĴΪ0xffffȫΪ1
	do
	{
		crc16 ^= (u16)*p;		//8λ16λCRCĴĵλ򣬰ѽCRCĴ
		for(i=0; i<8; i++)		//8λ
		{
			if(crc16 & 1)	crc16 = (crc16 >> 1) ^ 0xA001;	//λΪ0CRCĴһλ(λ)0λ
															//ʽ0xA001
			else	crc16 >>= 1;							//λΪ0CRCĴһλ(λ)0λ
		}
		p++;
	}while(--n != 0);
	return	(crc16);
}	


/*************	ADCú **************/
#define ADC_START	(1<<6)	/* Զ0 */
#define ADC_FLAG	(1<<5)	/* 0 */

#define	ADC_SPEED	1		/* 0~15, ADCʱ = SYSclk/2/(n+1) */
#define	RES_FMT		(1<<5)	/* ADCʽ 0: , ADC_RES: D9 D8 D7 D6 D5 D4 D3 D2, ADC_RESL: D1 D0 0  0  0  0  0  0 */
							/*             1: Ҷ, ADC_RES: 0  0  0  0  0  0  D9 D8, ADC_RESL: D7 D6 D5 D4 D3 D2 D1 D0 */

#define CSSETUP		(0<<7)	/* 0~1,  ADCͨѡʱ      0: 1ADCʱ, 1: 2ADCʱ,  Ĭ0(Ĭ1ADCʱ)	*/
#define CSHOLD		(1<<5)	/* 0~3,  ADCͨѡ񱣳ʱ  (n+1)ADCʱ, Ĭ1(Ĭ2ADCʱ)					*/
#define SMPDUTY		10		/* 10~31, ADCģźŲʱ  (n+1)ADCʱ, Ĭ10(Ĭ11ADCʱ)				*/
							/* ADCתʱ: 10λADC̶Ϊ10ADCʱ, 12λADC̶Ϊ12ADCʱ. 				*/

void ADC_Config(void)
{
	P_SW2 |=  0x80;	//XSFR
	P1n_pure_input(0x40);	//ҪADCIO
	ADC_CONTR = 0x80 + 6;	//ADC on + channel
	ADCCFG = RES_FMT + ADC_SPEED;
	ADCTIM = CSSETUP + CSHOLD + SMPDUTY;
}

//========================================================================
// : u16	Get_ADC12bitResult(u8 channel))	//channel = 0~11,15
// : ѯһADC.
// : channel: ѡҪתADCͨ0~15, chn=0~2ӦӦP1.0 P1.1 P5.4, chn=3~7ӦP1.3~P1.7, chn=8~14ӦP0.0~P0.6, chn=15ӦBandGapѹ.
// : 10λADC.
// 汾: V1.0, 2018-11-28
//========================================================================
u16	Get_ADC12bitResult(u8 channel)
{
	u8	i;
	ADC_RES = 0;
	ADC_RESL = 0;
	ADC_CONTR = 0x80 | ADC_START | channel; 
	NOP(10);			//
	i = 250;
	do
	{
		if((ADC_CONTR & ADC_FLAG) != 0)	//ADC
		{
			ADC_CONTR &= ~ADC_FLAG;
			return	((u16)ADC_RES * 256 + (u16)ADC_RESL);
		}
	}
	while(--i);
	return 0;
}


//**********************************ѹ***************************************
void AD_Battery(void)
{
	ADC6_Last = ((ADC6_Last * 3) >> 2) + Get_ADC12bitResult(6);
//	adc6 = ADC6_Last >> 2;
//	Battery = (u16)((float)ADC6_Last * 0.11781f);//A1#	STC32G汾	20K+6.8K 78M05׼
	Battery = (u16)((float)ADC6_Last * 0.080288f);//A1#	STC32G汾	20K+6.8K AMS1117-3.3׼
}




