
#include	"config.h"
#include	"NRF24L01.H"


#define RF_CHANNEL		110		// Ƶ = (2400 + RF_CHANNEL)  (MHZ)

sbit	P_24L01_CE		= P2^0;
sbit	P_24L01_CSN		= P4^4;
sbit	P_24L01_SCK		= P2^2;
sbit 	P_24L01_MOSI	= P2^1;
sbit 	P_24L01_MISO	= P2^4;
sbit	P_24L01_IRQ		= P2^3;


//*********************************************NRF24L01*************************************
#define TX_ADR_WIDTH    5   	// 5 chars TX address width
#define RX_ADR_WIDTH    5   	// 5 chars RX address width
#define TX_PLOAD_WIDTH  20  	// 20 chars TX payload
#define RX_PLOAD_WIDTH  20  	// 20 chars TX payload
u8 code TX_ADDRESS[TX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//صַ
u8 code RX_ADDRESS[RX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//յַ

//***************************************NRF24L01Ĵָ*******************************************************
#define READ_REG        0x00  	// Ĵָ
#define WRITE_REG       0x20 	// дĴָ
#define RD_RX_PLOAD     0x61  	// ȡָ
#define WR_TX_PLOAD     0xA0  	// дָ
#define FLUSH_TX        0xE1 	// ϴ FIFOָ
#define FLUSH_RX        0xE2  	// ϴ FIFOָ
#define REUSE_TX_PL     0xE3  	// ظװָ
//#define NOP             0xFF  	// 

//*************************************SPI(nRF24L01)Ĵַ****************************************************
#define CONFIG2         0x00  // շ״̬CRCУģʽԼշ״̬Ӧʽ
#define EN_AA           0x01  // ԶӦ
#define EN_RXADDR       0x02  // ŵ
#define SETUP_AW        0x03  // շַ
#define SETUP_RETR      0x04  // Զط	bit7~bit4: طʱ(n+1)*250 us, bit3~bit0: ط(0ʱֹط) 
#define RF_CH           0x05  // Ƶ
#define RF_SETUP        0x06  // ʡĹ
#define STATUS          0x07  // ״̬Ĵ
#define OBSERVE_TX      0x08  // ͼ⹦
#define CD              0x09  // ַ           
#define RX_ADDR_P0      0x0A  // Ƶ0ݵַ
#define RX_ADDR_P1      0x0B  // Ƶ1ݵַ
#define RX_ADDR_P2      0x0C  // Ƶ2ݵַ
#define RX_ADDR_P3      0x0D  // Ƶ3ݵַ
#define RX_ADDR_P4      0x0E  // Ƶ4ݵַ
#define RX_ADDR_P5      0x0F  // Ƶ5ݵַ
#define TX_ADDR         0x10  // ͵ַĴ
#define RX_PW_P0        0x11  // Ƶ0ݳ
#define RX_PW_P1        0x12  // Ƶ0ݳ
#define RX_PW_P2        0x13  // Ƶ0ݳ
#define RX_PW_P3        0x14  // Ƶ0ݳ
#define RX_PW_P4        0x15  // Ƶ0ݳ
#define RX_PW_P5        0x16  // Ƶ0ݳ
#define FIFO_STATUS     0x17  // FIFOջջ״̬Ĵ



//*****************************************ʱ*****************************************
/*
void Delay(u16 s)
{
	u16 i;
	for(i=0; i<s; i++);
	for(i=0; i<s; i++);
}

*/
//******************************************************************************************
u8 	bdata sta;   //״̬־
sbit	RX_DR	= sta^6;
sbit	TX_DS	= sta^5;
sbit	MAX_RT	= sta^4;
sbit	TX_FULL = sta^0;
/******************************************************************************************
/*ʱ
/******************************************************************************************/
void inerDelay_us(u8 n)
{
	for(; n>0; n--)
		_nop_();
}

//****************************************************************************************
/*NRF24L01ʼ
//***************************************************************************************/
void init_NRF24L01(void)
{
	inerDelay_us(1200);
	P_24L01_CE  = 0;	// chip enable
	P_24L01_CSN = 1;	// Spi  disable 
	P_24L01_SCK = 0;	// 
	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);		// дصַ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH);	// дն˵ַ
	SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);		//  Ƶ0Զ	ACKӦ	
	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);	//  յַֻƵ0ҪƵԲοPage21  
	SPI_RW_Reg(WRITE_REG + RF_CH, RF_CHANNEL);	//	ŵΪ2.4GHZշһ
	SPI_RW_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH);	//ýݳȣΪ32ֽ
	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x27);		//÷Ϊ1MB/S书Ϊֵ+7dBX2401Lţʵ+21dbm
	SPI_RW_Reg(WRITE_REG + CONFIG2, 0x5e); 
//	SPI_RW_Reg(WRITE_REG + SETUP_RETR, 0x13);		// Զط	bit7~bit4: طʱ(n+1)*250 us, bit3~bit0: ط(0ʱֹط) 
}


/****************************************************************************************************
/*u8 SPI_RW(u8 u8)
/*ܣNRF24L01SPIдʱ
/****************************************************************************************************/
u8 SPI_RW(u8 dat)
{
    B = dat;
	P_24L01_MOSI = B7;	P_24L01_SCK = 1;	B7 = P_24L01_MISO;	P_24L01_SCK = 0;
	P_24L01_MOSI = B6;	P_24L01_SCK = 1;	B6 = P_24L01_MISO;	P_24L01_SCK = 0;
	P_24L01_MOSI = B5;	P_24L01_SCK = 1;	B5 = P_24L01_MISO;	P_24L01_SCK = 0;
	P_24L01_MOSI = B4;	P_24L01_SCK = 1;	B4 = P_24L01_MISO;	P_24L01_SCK = 0;
	P_24L01_MOSI = B3;	P_24L01_SCK = 1;	B3 = P_24L01_MISO;	P_24L01_SCK = 0;
	P_24L01_MOSI = B2;	P_24L01_SCK = 1;	B2 = P_24L01_MISO;	P_24L01_SCK = 0;
	P_24L01_MOSI = B1;	P_24L01_SCK = 1;	B1 = P_24L01_MISO;	P_24L01_SCK = 0;
	P_24L01_MOSI = B0;	P_24L01_SCK = 1;	B0 = P_24L01_MISO;	P_24L01_SCK = 0;
	P_24L01_MOSI = 0;
    return(B);		// return read byte
}

/****************************************************************************************************
/*u8 SPI_Read(u8 reg)
/*ܣNRF24L01SPIʱ
/****************************************************************************************************/
/*
u8 SPI_Read(u8 reg)
{
	u8 reg_val;

	P_24L01_CSN = 0;		// CSN low, initialize SPI communication...
	inerDelay_us(12);
	SPI_RW(reg);			// Select register to read from..
	inerDelay_us(12);
	reg_val = SPI_RW(0);	// ..then read registervalue
	inerDelay_us(12);
	P_24L01_CSN = 1;		// CSN high, terminate SPI communication

	return(reg_val);		// return register value
}
*/

/****************************************************************************************************/
/*ܣNRF24L01дĴ
/****************************************************************************************************/
u8 SPI_RW_Reg(u8 reg, u8 value)
{
	u8 status;

	P_24L01_CSN = 0;		// CSN low, init SPI transaction
	status = SPI_RW(reg);	// select register
	SPI_RW(value);			// ..and write value to it..
	P_24L01_CSN = 1;		// CSN high again
	
	return(status);			// return nRF24L01 status u8
}

/****************************************************************************************************/
/*u8 SPI_Read_Buf(u8 reg, u8 *pBuf, u8 uchars)
/*: ڶݣregΪĴַpBufΪݵַucharsݵĸ
/****************************************************************************************************/
/*
u8 SPI_Read_Buf(u8 reg, u8 *pBuf, u8 uchars)
{
	u8 status, i;

	P_24L01_CSN = 0;			// Set CSN low, init SPI tranaction
	status = SPI_RW(reg);		// Select register to write to and read status u8

	for(i=0; i<uchars; i++)
	pBuf[i] = SPI_RW(0);

	P_24L01_CSN = 1;                           

	return(status);				// return nRF24L01 status u8
}

*/
/*********************************************************************************************************
/*u8 SPI_Write_Buf(u8 reg, u8 *pBuf, u8 uchars)
/*: дݣΪĴַpBufΪдݵַucharsдݵĸ
/*********************************************************************************************************/
u8 SPI_Write_Buf(u8 reg, u8 *pBuf, u8 uchars)
{
	u8 status, i;

	P_24L01_CSN = 0;		//SPIʹ       
	status = SPI_RW(reg);   
	for(i=0; i<uchars; i++)		SPI_RW(*pBuf++);
	P_24L01_CSN = 1;		//رSPI
	return(status);
}

/****************************************************************************************************/
/*void SetRX_Mode(void)
/*ܣݽ 
/****************************************************************************************************/
/*
void SetRX_Mode(void)
{
	P_24L01_CE = 0;
	SPI_RW_Reg(WRITE_REG + CONFIG2, 0x5f);		// IRQշжӦ16λCRC	
	P_24L01_CE = 1; 
	inerDelay_us(1560);		//ĿΪģ㹻ʱյ
}
*/

/******************************************************************************************************/
/*u8 nRF24L01_RxPacket(u8 *rx_buf)
/*ܣݶȡrx_bufջ
/******************************************************************************************************/
/*
void nRF24L01_RxPacket(u8 *rx_buf)
{
	sta = SPI_Read(STATUS);	
	if(RX_DR)				
	{
		P_24L01_CE = 0; 		
		SPI_Read_Buf(RD_RX_PLOAD,rx_buf,TX_PLOAD_WIDTH);	
	}
	SPI_RW_Reg(WRITE_REG+STATUS,sta);   //յݺRX_DR,TX_DS,MAX_PTøΪ1ͨд1жϱ־
	P_24L01_CE = 1;
}
*/

/***********************************************************************************************************
/*void nRF24L01_TxPacket(u8 *tx_buf)
/*ܣ tx_buf
/**********************************************************************************************************/
void nRF24L01_TxPacket(u8 *tx_buf)
{
	SPI_RW_Reg(WRITE_REG+STATUS,0xff);
	SPI_RW_Reg(0xE1,0xff);
	P_24L01_CE = 0;		
	SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH); 			       	
	P_24L01_CE = 1;		 
	inerDelay_us(10);   //CEߵƽ10usܽ뷢ģʽ
}