
#include	"config.h"
#include	"UART1.h"


/*************	˵	**************

ײ򡣿config.hֹ

******************************************/

#if (TASK_EN > 0)
	u8		waite_cnt1;
	#define 	WaitCheck	if(waite_cnt1!=0)	waite_cnt1--

void Task_Wait(u8 dly);
#endif



/****************************************************************************************/

#define BaseTime	ACC=CNT_ms;	++CNT_ms;	FG_ms = FG_ms | ((ACC ^ CNT_ms) & CNT_ms)


#if (D_1ms_CNT > 1)
	u8	CNT_1ms;
#endif
u8 	bdata	FG_ms;
u8 	CNT_ms;
#if (TIMER_512ms_EN > 0)
	u8	CNT_S;
#endif

sbit FG_ms0 = FG_ms^0;
sbit FG_ms1 = FG_ms^1;
sbit FG_ms2 = FG_ms^2;
sbit FG_ms3 = FG_ms^3;
sbit FG_ms4 = FG_ms^4;
sbit FG_ms5 = FG_ms^5;
sbit FG_ms6 = FG_ms^6;
sbit FG_ms7 = FG_ms^7;

/**********************		******************/
void	Time2ms(void);
void	Time4ms(void);
void	Time8ms(void);
void	Time16ms(void);
void	Time32ms(void);
void	Time64ms(void);
void	Time128ms(void);
void	Time256ms(void);
void	Time512ms(void);
void	Time1S(void);
void	Time2S(void);
void	Time4S(void);
void	Time8S(void);
void	Time16S(void);
void	Time32S(void);
void	Time64S(void);

void	user_init(void);		//ûϵʼ
void	UserTimer0_int(void);
void	main_function(void);	//ص
void	TaskA(void);


/**********************************************/
void InitTimer(void)
{
	InternalRAM_enable();
//	ExternalRAM_enable();

	Timer0_1T();
	Timer0_AsTimer();
	Timer0_16bitAutoReload();
	T0_Load(65536-Timer0_Reload);
	Timer0_InterruptEnable();
	Timer0_Run();

	//	EA  = 1;
	#if (D_1ms_CNT > 1)
		CNT_1ms  = 4;
	#endif
}

extern	u8	scan_index;
extern	u8	KeyCode;
extern	u8	KeyStateL, KeyStateR;
extern	u8	LED_L, LED_R;

void	KeyScan(void)
{
	u8	i;

	if((scan_index == 0) || (scan_index == 4))	// scan_index < 8
	{
	//	P_KEY_L = 1;
	//	P_KEY_R = 1;
		P_LED_L = 1;
		P_LED_R = 1;
		P3n_push_pull(B1110_0000);
		P4n_push_pull(B0000_1110);
		if(scan_index == 0)		B = LED_L;
		else					B = LED_R;
		P_Line1	= B0;
		P_Line2	= B1;
		P_Line3	= B2;
		P_Line4	= B3;
		P_Line5	= B4;
		P_Line6	= B5;
		if(scan_index == 0)		P_LED_L = 0;
		else					P_LED_R = 0;
	}
	if(scan_index >= 8)
	{
		P_LED_L = 1;
		P_LED_R = 1;
		P3n_standard(B1110_0000);
		P4n_standard(B0000_1110);
		P_Line1	= 1;
		P_Line2	= 1;
		P_Line3	= 1;
		P_Line4	= 1;
		P_Line5	= 1;
		P_Line6	= 1;
		if(scan_index == 8)	P_KEY_L = 0;
		else if(scan_index == 9)
		{
			B0 = ~P_ON_OFF;	B1 = P_Line2;	B2 = P_Line3;	B3 = P_Line4;	B4 = P_Line5;	B5 = P_Line6;
			i = KeyStateL;	KeyStateL = ~B & 0x3f;
			B = (i ^ KeyStateL) & KeyStateL;
			P_KEY_L = 1,	P_KEY_R = 0;
			if(B != 0)
			{
				if(B0)	KeyCode = KEY_ON_OFF;
				if(B1)	KeyCode = KEY1;
				if(B2)	KeyCode = KEY2;
				if(B3)	KeyCode = KEY3;
				if(B4)	KeyCode = KEY4;
				if(B5)	KeyCode = KEY5;
			}
		}
		else if(scan_index == 10)
		{
			B0 = P_Line1;	B1 = P_Line2;	B2 = P_Line3;	B3 = P_Line4;	B4 = P_Line5;	B5 = P_Line6;
			i = KeyStateR;	KeyStateR = ~B & 0x3f;
			B = (i ^ KeyStateR) & KeyStateR;
			P_KEY_R = 1;
			if(B != 0)
			{
				if(B1)	KeyCode = KEY10;
				if(B2)	KeyCode = KEY9;
				if(B3)	KeyCode = KEY7;
				if(B4)	KeyCode = KEY8;
				if(B5)	KeyCode = KEY6;
			}
		}
	}
	if(++scan_index >= 11)	scan_index = 0;
}



/**********************************************/
void timer0 (void) interrupt 1
{


	//**************************************************************
	#if (D_1ms_CNT > 1)
		if(--CNT_1ms == 0)
		{
			CNT_1ms = D_1ms_CNT;
	#else
		{
	#endif
			KeyScan();
			
			#if	(UART1 >0)
				if(RX1_Timer != 0)	{	if(--RX1_Timer == 0)	B_RX1_OK = 1;	}
			#endif

			#if	(UART2 >0)
				if(RX2_Timer != 0)	{	if(--RX2_Timer == 0)	B_RX2_OK = 1;	}
			#endif

			BaseTime;
			#if (TASK_EN > 0)
				WaitCheck;
			#endif
		}
}


/**********************************************/
void TimeProcess(void)
{
	if(FG_ms0)	{	FG_ms0 = 0;	Time2ms();}
	if(FG_ms1)	{	FG_ms1 = 0;	Time4ms();}
	if(FG_ms2)	{	FG_ms2 = 0;	Time8ms();}
	if(FG_ms3)	{	FG_ms3 = 0;	Time16ms();}
	if(FG_ms4)	{	FG_ms4 = 0;	Time32ms();}
	if(FG_ms5)	{	FG_ms5 = 0;	
					#if	(WDT_en > 0)
						WDT_reset(D_WDT_SCALE_128);
					#endif
								Time64ms();}
	if(FG_ms6)	{	FG_ms6 = 0;	Time128ms();}
	if(FG_ms7)
	{					FG_ms7 = 0;	Time256ms();

	#if (TIMER_512ms_EN > 0)
		ACC = CNT_S;
		++CNT_S;
		B = (ACC ^ CNT_S) & CNT_S;

			 if(B0)	Time512ms();
		else if(B1)	Time1S();
		else if(B2)	Time2S();
		else if(B3)	Time4S();
		else if(B4)	Time8S();
		else if(B5)	Time16S();
		else if(B6)	Time32S();
		else if(B7)	Time64S();
	#endif
	}
}
/**********************************************/

/**********************************************/
void main(void)
{
	InitTimer();
	user_init();

	EA  = 1;

while(1)
	{
		#if (TASK_EN > 0)
			TaskA();
		#else
			#if (MCU_IDLE_EN > 0)
				MCU_IDLE();		//IDLE
				_nop_();
				_nop_();
			#endif

			if(FG_ms != 0)	TimeProcess();
			main_function();		//ص
		#endif
	}
} 
/**********************************************/

/**********************************************/
#if (TASK_EN > 0)
	void	Task_Wait(u8 dly)
	{
		waite_cnt1 = dly;

		while(waite_cnt1 != 0)
		{
			#if (MCU_IDLE_EN > 0)
				MCU_IDLE();		//IDLE
				_nop_();
				_nop_();
			#endif

			main_function();		//ص
			if(FG_ms != 0)	TimeProcess();
		}
	}
#endif

